// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#include <fennec/core/logger.h>
#include <fennec/platform/interface/display_server.h>
#include <fennec/platform/interface/platform.h>

namespace fennec
{

platform::platform() {
	assertf(instance() == nullptr, "Attempted to instantiate multiple platforms.");
	instance() = this;
}

void platform::initialize() {
	if (wmanager) {
		return;
	}

	logger::log(logger::alert, format("Initializing platform {}", get_type().name()));

	// Setup Window Manager
	wmanager = make_unique<window_manager>(this);
	wmanager->initialize();
}

void platform::shutdown() {

	// Cleanup Window Manager
	wmanager->shutdown();
	wmanager.reset();
}

}
